Name: pdnsd
Version: 1.1.7a
Release: alt6

Summary: A caching DNS proxy for small networks and dialup users
License: GPL
Group: System/Servers

Url: http://home.t-online.de/home/Moestl/
Source: %url/%name-%version.tar.bz2

Source1: %name.init
Source2: %name.conf
Source3: %name.ip-up
Source4: %name.init.old

Patch1: %name-1.1.7a-pld-threads_signals.patch
Patch2: droppriv-user-dir.patch
Patch3: preload-protoent.patch
Patch4: %name-1.1.7a-alt-droppriv.patch
Patch5: %name-1.1.7a-alt-preload-protoent.patch
Patch6: %name-1.1.7a-alt-stupid.patch
Patch7: %name-1.1.7a-deb-changeable_ip.patch
Patch8: %name-1.1.7a-deb-so_reuseaddr.patch
Patch9: %name-1.1.7a-alt-global-sock_path.patch
Patch10: %name-1.1.7a-alt-stat_sock-bugfix.patch
Patch11: %name-1.1.7a-alt-chroot-syslog.patch
Patch12: %name-1.1.7a-alt-cache.patch
Patch13: %name-1.1.7a-alt-chroot-reorder.patch
Patch14: %name-1.1.7a-alt-makefile.patch
Patch15: %name-1.1.7a-alt-test-fixup.patch
Patch16: %name-1.1.7a-alt-getopt.patch

BuildPreReq: /usr/bin/mksock

# Automatically added by buildreq on Sat Aug 23 2003
BuildRequires: flex

BuildPreReq: automake_1.6
%set_automake_version 1.6
BuildPreReq: autoconf_2.5
%set_autoconf_version 2.5

Requires: /var/empty /etc/ppp/ip-up.d

%description
pdnsd is a proxy DNS daemon with permanent (disk-)cache and the ability to
serve local records.  It is designed to detect network outages or hangups and
to prevent DNS-dependent applications like Netscape Navigator from hanging.

%prep
%setup -q
%patch1 -p1
cd src
%patch2
%patch3
cd ..
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1

%build
%__aclocal
%__automake -a -f
%__autoconf
%configure --with-default-id=%name
%make_build

%install
%make_install DESTDIR=$RPM_BUILD_ROOT install
%__mkdir_p $RPM_BUILD_ROOT{%_docdir/%name-%version,%_cachedir/%name,%_var/run/%name}
%__rm -f contrib/Makefile*
%__cp -a contrib $RPM_BUILD_ROOT%_docdir/%name-%version
%__cp -a doc/txt $RPM_BUILD_ROOT%_docdir/%name-%version
%__cp -a doc/html $RPM_BUILD_ROOT%_docdir/%name-%version
%__cp -a AUTHORS ChangeLog ChangeLog.old COPYING COPYING.BSD INSTALL NEWS \
	README THANKS TODO doc/pdnsd.conf $RPM_BUILD_ROOT%_docdir/%name-%version

%__install -pD -m755 %SOURCE1 $RPM_BUILD_ROOT%_initdir/%name
%__install -pD -m755 %SOURCE2 $RPM_BUILD_ROOT%_sysconfdir/%name.conf
%__install -pD -m755 %SOURCE3 $RPM_BUILD_ROOT%_sysconfdir/ppp/ip-up.d/0%name

touch $RPM_BUILD_ROOT%_cachedir/%name/%name.cache
mksock $RPM_BUILD_ROOT%_var/run/%name/socket

%files
%_sbindir/%{name}*
%_docdir/%name-%version
%_mandir/man?/%{name}*
%config %_initdir/%name
%config %_sysconfdir/ppp/ip-up.d/0%name
%config(noreplace) %_sysconfdir/%name.conf
	%attr(700,root,%name) %dir %_var/run/%name
%ghost	%attr(600,root,%name) %_var/run/%name/socket
	%attr(700,root,%name) %dir %_cachedir/%name
%ghost	%attr(600,root,%name) %verify(not md5 mtime size) %config(noreplace) %_cachedir/%name/%name.cache

%pre
/usr/sbin/groupadd -r -f %name >/dev/null 2>&1 ||:
/usr/sbin/useradd -r -g %name -d /dev/null -s /dev/null -n %name >/dev/null 2>&1 ||:

%post
[ -s %_cachedir/%name/%name.cache ] || \
	dd if=/dev/zero of=%_cachedir/%name/%name.cache bs=1 count=4 >/dev/null 2>&1 ||:
%__chmod 0660 %_cachedir/%name/%name.cache
%__chown root:%name %_cachedir/%name/%name.cache
%post_service %name

%preun
%preun_service %name

%changelog
* Sat Aug 23 2003 Alexey Tourbin <at@altlinux.ru> 1.1.7a-alt6
- new init script according to new rc scheme
- cache.c:
  + s/alt-chroot-disk-cache.patch/cache.patch/
  + keep cache file stream always open
  + eliminate the use of fseek on writes (Paul Rombouts)
- main.c: command line parser reworked utilizing getopt_long(3)
- ipvers.h: remove stale glibc code
- configure.in: dropped some CFLAGS because they are in acconfig.h

* Sun May 11 2003 Alexey Tourbin <at@altlinux.ru> 1.1.7a-alt5
- fixed alt-chroot-disk-cache.patch that could lead to crash
- pdnsd is no longer maintained by its author; going to start my own CVS repo
- Sisyphus release (works fine for me)

* Mon Jan 27 2003 Alexey Tourbin <at@altlinux.ru> 1.1.7a-alt4
- doesnot build with automake-1.7; exact version specified for
  automake (1.6) and autoconf (2.5) in BuildPreReq
- minor fixes

* Wed Jan 22 2003 Alexey Tourbin <at@altlinux.ru> 1.1.7a-alt3
- major revision; new features added; works now out of the box
- alt patches: now able to work in empty chrooted environment
  + droppriv patches: global chroot_dir config option, chroot code
  + protoent, chroot patches: open resources before chroot
  + global-sock_path: control socket path configurable; not finished
    because can't link pdnsd-ctl against it
  + note that some features will not work when chrooted
- debian patches:
  + changeable_ip: manipulate server ip via control socket
  + so_reuseaddr: smoother restart
- default configuration file (supposed to be suitable for dialup):
  + chrooted to /var/empty
  + use {A,B}.ROOT-SERVERS.NET by default
  + changeble_ip enabled
- /etc/ppp/ip-up.d/0pdnsd: change server ip whenever peer DNS is available

* Fri Sep 20 2002 Alexey Tourbin <at@turbinal.org> 1.1.7a-alt2
- PLD patch applied which claims to fix SIGTERM handling for threads
- init script: sleep 2 after killproc (still thread problems)
- Sisyphus candidate

* Sun Jul 21 2002 Alexey Tourbin <at@turbinal.org> 1.1.7a-alt1
- 1.1.7a
- init script rewritten
- custom PPP init scheme suggested (pdnsd.conf.in and pdnsd.ip-up.local)
- ALT Linux adoptions

* Sun May 16 2001 Thomas Moestl <tmoestl@gmx.net>
- Make use of chkconfig for Red Hat (patch by Christian Engstler)
* Sun Mar 25 2001 Thomas Moestl <tmoestl@gmx.net>
- Merged SuSE fixes by Christian Engstler
* Fri Feb 09 2001 Thomas Moestl <tmoestl@gmx.net>
- Merged in a spec fix for mapage inclusion contributed by Sourav K.
  Mandal
* Sun Nov 26 2000 Thomas Moestl <tmoestl@gmx.net>
- Added some patches contributed by Bernd Leibing
* Tue Aug 15 2000 Thomas Moestl <tmoestl@gmx.net>
- Added the distro for configure
* Tue Jul 11 2000 Sourav K. Mandal <smandal@mit.edu>
- autoconf/automake modifications
